#! /bin/bash

CUDA_VERSION=$(echo `nvcc -V` | awk 'BEGIN{RS=","} /^ release/{print}' | awk '{print $2}')
export CUDA_VER=$CUDA_VERSION
echo "cuda version:"$CUDA_VER

if [ ! -d "./build/" ];then
  mkdir build
  echo "创建build目录"
else
  rm build -r
  echo "删除build目录"
  mkdir build
  echo "创建build目录"
fi


function  get_sub_path()
{
    split_path=`echo $1 | sed "s/\// /g"`
    sub_path=`echo $split_path| awk 'NR==1{print $NF}'`
    echo $sub_path
}

project_path=`pwd`
source_path=`pwd`"/../../../"
for file in $source_path/*      #注意此处这是两个反引号，表示运行系统命令
    do
        if [ -d $file ];then
          #获取最后一级目录
          libs_path=$(echo `get_sub_path $file`)

          if [ "$libs_path" = "libs" -o "$libs_path" = "gst-plugins" ];then
            for lib in $file/*
              do
                sub_lib_path=$(echo `get_sub_path $lib`)
                if [ "$sub_lib_path" = "amqp_protocol_adaptor" -o "$sub_lib_path" = "azure_protocol_adaptor" \
                 -o "$sub_lib_path" = "nvmsgbroker" -o "$sub_lib_path" = "redis_protocol_adaptor" ];then
                  continue
                fi
                cd $lib && make clean && make install -j
              done
          fi

        fi
    done

cd $project_path"/nvdsinfer_custom_impl_Yolo"
make clean
make install
cd $project_path
make clean
make -j

cp -r /opt/nvidia/deepstream/deepstream/lib  build/dp_lib
echo "cp -r /opt/nvidia/deepstream/deepstream/lib  build/dp_lib"

cp  deepstream-test5-app  build/
echo "cp  deepstream-test5-app  build/"
cp -r configs  build/
echo "cp -r configs  build/"
cp -r models  build/
echo "cp -r models  build/"
cp  monitor.py  build/
echo "cp  monitor.py  build/"

