/*
 * Copyright (c) 2019-2020, NVIDIA CORPORATION. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#ifndef __DEEPSTREAM_TEST5_APP_H__
#define __DEEPSTREAM_TEST5_APP_H__

#include <gst/gst.h>
#include "deepstream_config.h"
#include "deepstream_app.h"
#include <map>
/*const gchar sgie1_classes_str[4][32] = {
    "NO_HELMET", "NO_MASK", "FALL_DOWN", "SMOKING"
};*/


typedef struct
{
    guint result_class_id;
    time_t last_time;
} LastEventInfo;


typedef struct
{
    int noHelmetNumber;
    int maskNumber;
    int fallNumber;
    int smokingNumber;
    time_t last_time;
} LastCountInfo;

typedef struct
{
  gint anomaly_count;
  gint meta_number;
  struct timespec timespec_first_frame;
  GstClockTime gst_ts_first_frame;
  GMutex lock_stream_rtcp_sr;
  guint32 id;
  gint frameCount;
  GstClockTime last_ntp_time;
    std::map<AttributeType, std::map<gint, LastEventInfo> > last_event_info;
    std::map<ObjectType, time_t > last_detect_info;
    LastCountInfo last_count;
} StreamSourceInfo;

typedef struct
{
  StreamSourceInfo streams[MAX_SOURCE_BINS];
} TestAppCtx;

struct timespec extract_utc_from_uri (gchar * uri);

#endif /**< __DEEPSTREAM_TEST5_APP_H__ */
