#! /bin/bash
if [ $# == 0 ];then
    echo "ERROR: missing parameter!!";
    echo "Usage:  docker_build.sh <version>";
    echo "Options:";
    echo "    version       major.second.patch(example: 1.0.0) ";
    set -e
else
    DOCKER_NEW_VERSION=$1
    TARGET_DEVICE=$(uname -m)
    if [ "${TARGET_DEVICE}" = "x86_64" ]; then
      PLATFORM="x86"
      SUFFIX=""
    else
      PLATFORM="iot"
      SUFFIX="-l4t"
    fi
    docker build --build-arg PLATFORM="${PLATFORM}" --build-arg SUFFIX="${SUFFIX}" -t nvcr.io/nvidia/deepstream${SUFFIX}:$DOCKER_NEW_VERSION  .
fi
